
#include <libc.h>
#include "analyze.h"

int verbose;

main(int argc, char **argv)
{
	int	c,i;

	while ((c=getopt(argc, argv, "v")) != -1) {
		switch (c) {
		case 'v': verbose = 1; break;
		default:
			break;
		}
	}
	for (i=optind; i < argc; i++) {
		BreakTab *b;
		int	n;
		ulong_t marks=0;
		ulong_t insns=0;
		ulong_t terms=0;

		if ((b=get_brtab(argv[i])) == 0) {
			fprintf(stderr, "can't read '%s'\n", argv[i]);
			continue;
		}
		for (n=0; n < b->bh.bsize; n++) {
			marks += br_ismarked(b,n);
			insns += br_isvisit(b,n);
			terms += br_isterm(b,n);
		}
		printf("%s bytes %lu\n",
			argv[i], n);
		printf("\tmarks % 8u %f%%\n",
			 marks, 100*(double)marks/(double)n);
                printf("\tinsns % 8u %f%%\n",
			 insns, 100*(double)insns/(double)n);
		printf("\tterms % 8u %f%%\n",
			 terms, 100*(double)terms/(double)n);
		delete_brtab(b);
	}
}
