
/*-
 * dump - dump the text segment of a program.
 */

#include <libc.h>
#include "ldfile.h"
#include "dbi.h"

int verbose = 0;

dumptext(char *src)
{
	FILE      *fp;
	lmfo      *obj;
	uchar_t   *text;

	if ((fp=fopen(src, "r")) == 0) {
		fprintf(stderr, "%s: cannot open\n", src);
		return -1;
	}

	if ((obj=lmf_open(fp)) == 0) {
		fclose(fp);
		return -1;
	}
	if (lmf_loadtext(obj, &text) == -1) {
		lmf_close(obj);
		return -1;
	}
	write(1, text, obj->code_size);
	lmf_close(obj);
	return 0;
}

main(int argc, char **argv)
{
	int	c, i;

	while ((c=getopt(argc, argv, "v")) != -1) {
		switch (c) {
		case 'v': verbose = 1; break;
		}
	}
	for (i=optind; i < argc; i++) {
		if (dumptext(argv[i]) == -1) {
			fprintf(stderr, "%s: couldn't dump %s\n", argv[0], argv[i]);
		}
	}
	return 0;
}



