/*-
 * lineno: convert addresses to linenumbers.
 *
 */
#ifdef __USAGE
%C prog [address...]
where:
  prog          full path of a program
  address       list of addresses to print lineno's from.
note:
  If no address is given on the command line, addresses are read from
  stdin.
  Addresses are in standard C syntax (0x...=hex, 0...=octal, def=decimal).
#endif

#include <libc.h>
#include "dbi.h"


print_lineno(lmfo *lo, ulong_t addr)
{
	char         buf[256];
	unsigned     lno = 0;
	buf[0] = '\0';
	if (lmf_a2l(lo, addr, buf, &lno) == 0) {
		if (lno == -1L) {
			if (lmf_a2m(lo, addr, buf, &lno) == 0) {
				printf("module %s+ 0x%lx\n", buf, lno);
			}
		} else {
			printf("line %s+%lu\n", buf, lno);
		}
	} else if (lmf_a2m(lo, addr, buf, &lno) == 0) {
		printf("module %s+ 0x%lx\n", buf, lno);
	} else {
		printf("unknown address 0x%lx\n", addr);
	}
	return 0;
}

main(int argc, char **argv)
{
	FILE	*fp;
	lmfo    *lo;
	char     buf[256];
	int	c;

	while ((c=getopt(argc, argv, "")) != -1);

	if (optind == argc) {
		fprintf(stderr, "need image name!\n");
		return 1;
	}
	if ((fp=fopen(argv[optind],"r")) == 0 || (lo=lmf_open(fp)) == 0) {
		fprintf(stderr, "can't get image\n");
		return 1;
	}
	if (++optind == argc) {
		while (gets(buf)) {
			ulong_t      addr = strtol(buf, 0, 16);
			print_lineno(lo, addr);
		}
	} else while (optind < argc) {
		print_lineno(lo, strtoul(argv[optind++], 0, 0));
	}
	lmf_close(lo);
	return 0;
}
