#include <libc.h>
#include "dbi.h"

int verbose;

main(int argc, char **argv)
{
	int	c;
	FILE   *outp = stdout;
	int    (*print)(lmfo *, FILE *) = lmf_print_globs;

	while ((c=getopt(argc, argv, "vsnmS")) != -1) {
		switch (c) {
		case 'v':
			verbose = 1;
			break;
		case 's':
			print = lmf_print_segments;
			break;
		case 'n':
			print = lmf_print_globs;
			break;
		case 'm':
			print = lmf_print_modules;
			break;
		case 'S':
			if ((outp=popen("sort -k1fr", "w")) == 0) {
				fprintf(stderr, "%s - could not open pipe to sort (%s)\n",
					argv[0], strerror(errno));
				return 1;
			}
		}
	}
	while (optind < argc) {
		FILE	*fp;
		lmfo    *lo;
		if ((fp=fopen(argv[optind], "r")) == 0) {
			fprintf(stderr, "%s - could not open '%s' (%s)\n",
				argv[0], argv[optind], strerror(errno));
		} else if ((lo=lmf_open(fp)) == 0) {
			fprintf(stderr, "%s - lmf_open(%s) failed (%s)\n",
				argv[0], argv[optind], strerror(errno));
		} else {
			(*print)(lo, outp);
			lmf_close(lo);
		}
		optind++;
	}
	pclose(outp);
	return 0;
}
