
/*-
 * lmf_syms: symbol table information.
 */

#include <libc.h>
#include "dbi.h"

gbl_info *
lmf_lookup(lmfo *l, int segno, char *name)
{
	int	i;
	for (i=0; i < l->nglobs; i++) {
		gbl_info *p = l->globtab[i];
		if (p->addr.segment>>3 == segno &&
		    strcmp(p->name, name) == 0)
		    	return p;
	}
	return 0;
}

gbl_info *
lmf_lookuptext(lmfo *l, char *name)
{
	return lmf_lookup(l, 0, name);
}

gbl_info *
lmf_lookupdata(lmfo *l, char *name)
{
	return lmf_lookup(l, 1, name);
}


int
lmf_symiter(lmfo *l, symiter *it)
{
	it->lmfo = l;
	it->index = 0;
	return 0;
}

gbl_info *
lmf_symnext(symiter *it)
{
	int       n = it->index;

	if (n > it->lmfo->nglobs)
		return 0;
	it->index++;
	return it->lmfo->globtab[n];
}
